<script setup lang="ts">
import { onMounted, ref } from 'vue'
import MsnApiV1 from '@/api/msnApi'

const eventsList = ref([])
const itemsPerPage = ref(20)
const currentPage = ref(1)
const totalRows = ref(0)
const loading = ref(false)

const fields = ref([
  { key: 'name', title: 'Event name' },
  {
    key: 'created_at',
    title: 'Created',
    formatter: (value: string) => {
      const date = new Date(value)

      return `${date.toLocaleDateString()} ${date.toLocaleTimeString()}`
    },
  },
  { key: 'actions', title: 'Actions', sortable: false },
])

const getEvents = async (itemsPerPage: number, page: number) => {
  loading.value = true

  const msn = new MsnApiV1()

  try {
    const response = await msn.getAllEvents(itemsPerPage, page)

    eventsList.value = response.data.data
    totalRows.value = Number(response.headers['x-total'])
  }
  catch (error) {
    console.error('Error fetching events:', error)
  }
  finally {
    loading.value = false
  }
}

// Llamar a la API para obtener eventos cuando el componente se monte
onMounted(() => {
  getEvents(itemsPerPage.value, currentPage.value)
})

// Llamar a la API cuando cambian los valores de paginación o la página actual
const fetchData = ({ itemsPerPage, page }) => {
  getEvents(itemsPerPage, page)
}

const editDialog = ref(false)
const deleteDialog = ref(false)
const editedItem = ref(null)
const editedIndex = ref(-1)

const editItem = item => {
  editedIndex.value = eventsList.value.indexOf(item)
  editedItem.value = { ...item }
  editDialog.value = true
}

const deleteItem = item => {
  editedIndex.value = eventsList.value.indexOf(item)
  editedItem.value = { ...item }
  deleteDialog.value = true
}

const close = () => {
  editDialog.value = false
  editedIndex.value = -1
}

const closeDelete = () => {
  deleteDialog.value = false
  editedIndex.value = -1
}

const deleteItemConfirm = async () => {
  const msn = new MsnApiV1()
  const eventId = editedItem.value.id

  try {
    await msn.deleteEvent(eventId)
    eventsList.value = eventsList.value.filter(event => event.id !== eventId)
  }
  catch (error) {
    console.error('Error deleting event:', error)
  }

  deleteDialog.value = false
}
</script>

<template>
  <SettingsTemplate>
    <h4>Event List</h4>

    <!-- Botón para añadir evento -->
    <VRow>
      <VCol
        cols="12"
        class="d-flex justify-end"
      >
        <VBtn
          :to="{ name: 'settings-event-new' }"
          color="primary"
        >
          Add event
        </VBtn>
      </VCol>
    </VRow>

    <!-- Tabla de eventos con paginación -->
    <VDataTableServer
      v-model:items-per-page="itemsPerPage"
      v-model:page="currentPage"
      :headers="fields"
      :items="eventsList"
      :items-length="totalRows"
      :loading="loading"
      class="elevation-1"
      loading-text="Loading... Please wait"
      density="compact"
      @update:options="fetchData"
    >
      <!-- Nombre del evento -->
      <template #item.name="{ item }">
        <p>{{ item.name }}</p>
      </template>

      <!-- Acciones: Editar y eliminar -->
      <template #item.actions="{ item }">
        <div class="d-flex gap-1">
          <!--
            IconBtn @click="editItem(item)">
            <VIcon icon="tabler-edit" />
            </IconBtn
          -->
          <IconBtn @click="deleteItem(item)">
            <VIcon
              color="error"
              icon="tabler-trash"
            />
          </IconBtn>
        </div>
      </template>
    </VDataTableServer>

    <!-- Diálogo para eliminar -->
    <VDialog
      v-model="deleteDialog"
      max-width="500px"
    >
      <VCard>
        <VCardTitle>Are you sure you want to delete this item?</VCardTitle>
        <VCardActions>
          <VSpacer />
          <VBtn
            color="error"
            @click="closeDelete"
          >
            Cancel
          </VBtn>
          <VBtn
            color="success"
            @click="deleteItemConfirm"
          >
            OK
          </VBtn>
          <VSpacer />
        </VCardActions>
      </VCard>
    </VDialog>
  </SettingsTemplate>
</template>
